#include <iostream>
#include <memory>
#include <stdexcept>

struct X {
	X() { std::cout << "X created\n"; }
	~X() { std::cout << "X destroyed\n"; }
};

void possibly_throwing_function() {
	// throw std::runtime_error("D'oh!");
}

// think the following two functions are equivalent?
// try uncommenting the throw command above!
void good_function() {
	auto ptr = std::make_unique<X>();
	std::cout << "in good_function 1\n";
	possibly_throwing_function();
	std::cout << "in good_function 2\n";
}

void bad_function() {
	auto ptr = new X;
	std::cout << "in bad_function 1\n";
	possibly_throwing_function();
	std::cout << "in bad_function 2\n";
	delete ptr;
}

int main() {
	try {
		good_function();
	} catch (std::runtime_error& ex) {
		std::cout << "Error: " << ex.what() << '\n';
	}

	try {
		bad_function();
	} catch (std::runtime_error& ex) {
		std::cout << "Error: " << ex.what() << '\n';
	}
}
